#! /usr/bin/python
import os, sys
import time
import plistlib
import commands

def printLog(str):
    output.write(str + '\n')

#### Check if dir exists, if not, create then set permissions to 775 and owner to User
def mkdirIfNeeded(path, ownerName):
    if not os.path.exists(path):
        os.mkdir(path)
        os.chmod(path, 0775)
        chown_cmd = CHOWN + ' ' + ownerName + ' ' + path
        os.system(chown_cmd)
        
#### Passed PARAMETERS
appPath = sys.argv[1]
appName = sys.argv[2]
resourcesDir = sys.argv[3]
callingScriptPath = sys.argv[4]
payloadNum = sys.argv[5]

PID = os.getpid()
DEFAULTS =  "/usr/bin/defaults"
DITTO =     "/usr/bin/ditto"
RM =        "/bin/rm"
MKDIR =     "/bin/mkdir"
PAX =       "/bin/pax"
MV =        "/bin/mv"
CHMOD =     "/bin/chmod"
CHOWN =     "/usr/sbin/chown"
BSPATCH =   "/usr/bin/bspatch"
STAT =      "/usr/bin/stat"
COLRM =     "/usr/bin/colrm"
PLUTIL =    "/usr/bin/plutil"


ADOBE_PATCH_DIR	=	"/tmp/AdobePatch/"

appname = os.path.basename(os.path.dirname(os.path.dirname(os.path.dirname(callingScriptPath))))
logfile_name = appname.split('.')[0] + payloadNum + '.log'

homePath = os.path.expanduser("~")
pathComponents = os.path.split(homePath)
ownerName = pathComponents[1]
logfile_dir = os.path.join(homePath, "Library", "Logs")
mkdirIfNeeded(logfile_dir, ownerName)
logfile_dir = os.path.join(logfile_dir, "Adobe")
mkdirIfNeeded(logfile_dir, ownerName)
logfile_dir = os.path.join(logfile_dir, "Acrobat")
mkdirIfNeeded(logfile_dir, ownerName)
logfile_path = os.path.join(logfile_dir, logfile_name)
output = open(logfile_path, 'w')
printLog('Executing ApplyOperation.py for payload: ' + payloadNum)
now = time.localtime(time.time())
printLog(time.strftime("Start Time-   %m/%d/%y  %H:%M:%S", now))

#### Extract at temporary location
Resources = resourcesDir.rstrip('/') + '/payload' + payloadNum + '.cpio.gz'
srcResDir = ADOBE_PATCH_DIR + str(PID)
backupDir = srcResDir + "/backup"

#Flush the temp folder if present 
rm_cmd = RM + " -fR \'" + srcResDir + "\'"
printLog(rm_cmd)
os.system(rm_cmd)

mkdir_cmd = MKDIR + " -p -m 775 \'" + backupDir + "\'"
printLog(mkdir_cmd)
os.system(mkdir_cmd)
ditto_cmd = DITTO + " -x -rsrcFork \'" + os.path.abspath(Resources) + "\' \'" + srcResDir + "\'"
printLog(ditto_cmd)
os.system(ditto_cmd)

#### File GLOBALS
payloadDir      =  srcResDir + "/payload"
manifestFile    =  payloadDir + "/manifest.plist"
undoFileWithExt =  backupDir + "/undoFile.plist"
undoFile        =  backupDir + "/undoFile"

plist = plistlib.Plist.fromFile(manifestFile)
createUndo = True
entry = {}
i = 0
length = len(plist.Fileset)

def calculate_cksum(path):
    chksum_cmd = "/usr/bin/cksum"
    cmd_string_ck1 = chksum_cmd + " \"" + path + "\""
    fi =  os.popen(cmd_string_ck1, 'r')
    line = fi.readline()
    status = fi.close()
    #  if path is bad return with -1
    if status > 0:
        printLog("This call failed: " + cmd_string_ck1)
        return -1
    line = line.rstrip('\n')
    output = line.split(' ')
    return output[0]

def createBackup(IsFolder, objLocation, backupFileName):
    printLog('Creating backup')
    if ( IsFolder ==  "True" ):
        cmd = DITTO + " -cz --keepParent -rsrcFork \"" + objLocation + "\" \'" + backupDir + '/' + backupFileName + "\'"
    else:
        cmd = DITTO + " -rsrc \"" + objLocation + "\" \'" + backupDir + '/' + backupFileName + "\'"
    printLog(cmd)
    err = os.system(cmd)
    return err

def isValidForLanguage(list):
    """
       Created 12/11/2006 by Matthew Homer. 
       Checks to verify that the target is of the correct language type.
       If the target type is on the comma delemined list, then return True.
       Otherwise, return False.
       Note:  the 80 in 80SelfHeal.xml may be a problem in the near future
    """
    if len(list)==0 or (len(list)==1 and len(list[0])<2):
        return True
        
    #restore appPath
    restoredAppPath = appPath
    restoredAppPath = restoredAppPath.replace('\\$', '$')
    restoredAppPath = restoredAppPath.replace('\\`', '`')
    restoredAppPath = restoredAppPath.replace('\\\"', '"')
    
    tempAppName = appName
    if appName == 'Acrobat Uninstaller.app':
        tempAppName = 'Adobe Acrobat Pro.app'
    
    initPath = os.path.join(restoredAppPath, tempAppName, "Contents", "MacOS", "SHInit.xml")
    shInitPlist = plistlib.Plist.fromFile(initPath)
    fileName = shInitPlist.get('selfhealingfilename')
    offset = fileName.find('90SelfHeal.xml')
    namePart = fileName[offset-4:offset]
    
    if fileName[offset-4:offset] == 'Dist':
       namePart = fileName[offset-8:offset-4]

    elif fileName[offset-3:offset] == 'Pro':
       namePart = fileName[offset-7:offset-3]

    if not (namePart=='ISDP' or namePart=='SDFN' or namePart=='RURT'):
       namePart = namePart[1:]

    optionList = list.split(',')
    for option in optionList:
        mes = 'namePart :' + namePart +' \toption : ' + option
        printLog(mes)
        if namePart == option:
            return True
    return False
    
def isCorrectFeatureLockDownFile(SourcePath, TargetPath):
    file1 = open(TargetPath, 'r')
    file2 = open(SourcePath, 'r')
    line1 = file1.readline()
    line2 = file2.readline()
    isFedEx1 = line1.find('FedExInternetPrintingEnabled [/b true]')!=-1
    isFedEx2 = line2.find('FedExInternetPrintingEnabled [/b true]')!=-1
    printLog("isCorrectFeatureLockDownFile-  isFedEx1: " + str(isFedEx1) + '   isFedEx2: ' + str(isFedEx2))
    return isFedEx1 == isFedEx2


def doOperation(entry):
    OpCode = entry["OpCode"]
    RelativeAppPath = entry["TargetPath"]
    IsFolder = entry["IsFolder"]
    PatchFileName = entry["PatchFileName"]
    ObjectName = entry["ObjectName"]
    OrigChecksum = entry["OrigChecksum"]
    FinalChecksum = entry["FinalChecksum"]
    LangID = entry["LangID"]
    UserID = entry["UserID"]
    GroupID = entry["GroupID"]
    Perms = entry["Perms"]
    
    if not isValidForLanguage(Perms):
        return 0

    err = 0
    printLog("OpCode : \'" + OpCode + "\'")
    SourcePath = payloadDir + '/' + PatchFileName
    
    #### Check to see if path is absolute or target relative
    if RelativeAppPath[0] == '/':
        TargetPath = RelativeAppPath.rstrip('/')
    else:
        TargetPath = appPath + '/' + RelativeAppPath.rstrip('/')

    if ( createUndo == False ):
        SourcePath = backupDir + '/' + PatchFileName

    #### This hack is to install "AuthPlayLib.bundle" only for i386, and not on ppc
    if ObjectName == 'AuthPlayLib.bundle':
        printLog("Got AuthPlayLib.bundle, checking processor architecture.")
        status, output = commands.getstatusoutput("uname -p")
        printLog(output)
        # In case of PPC skip this entry, but if it is PPC and we are trying to remove it, don't skip.
        if output == 'powerpc' and OpCode != "Delete":
            printLog("Skip updating AuthPlayLib.bundle, as it is powerpc architecture")
            return 0
        if output != 'powerpc' and OpCode == "Delete":
            printLog("Skip deleting AuthPlayLib.bundle, as it is not powerpc architecture")
            return 0

    #### This hack is to install "AuthPlayLibPPC.bundle" only for ppc, and not on i386
    if ObjectName == 'AuthPlayLibPPC.bundle':
        printLog("Got AuthPlayLibPPC.bundle, checking processor architecture.")
        status, output = commands.getstatusoutput("uname -p")
        printLog(output)
        # In case of non PPC skip this entry
        if output != 'powerpc':
            printLog("Skip updating AuthPlayLibPPC.bundle, as it is not powerpc architecture")
            return 0 

    ####  This hack is to check if target is FedEX Reader version and use the approproiate FeatureLockDown file
    if ObjectName == 'FeatureLockDown':
        if not isCorrectFeatureLockDownFile(SourcePath, TargetPath+'/FeatureLockDown'):
            return 0

    #### Identify command -> Create backup command -> perform the operation
    if OpCode == "Add":
        if ( createUndo ==  True ):
            printLog('Writing Backup Command')
            cmd = DEFAULTS + " write \'" + undoFile + "\' Fileset -array-add \"{ \"OpCode\" = Delete; \"TargetPath\" = \'" + RelativeAppPath + "\'; \"IsFolder\" = \'" + IsFolder + "\'; \"PatchFileName\" = \'" + PatchFileName + "\'; ObjectName = \'" + ObjectName + "\'; \"OrigChecksum\" = \'" + FinalChecksum + "\'; \"FinalChecksum\" = \'"+ OrigChecksum + "\'; \"LangID\" = \'" + LangID + "\'; \"UserID\" = \'" + UserID + "\'; \"GroupID\" = \'" + GroupID + "\'; \"Perms\" = \'" + Perms + "\'; }\""
            printLog(cmd) 
            os.system(cmd)
        if not os.path.exists(TargetPath):
            status, output = commands.getstatusoutput("%s -v -p -m 0775 \"%s\"" % (MKDIR, TargetPath))
            printLog(output)
            for dir in output.split('\n'):
                status, output = commands.getstatusoutput("%s %s:admin \"%s\"" % (CHOWN, ownerName, dir))
                printLog(output)
        if ( IsFolder == "True" ):
            cmd = DITTO + " -x \'" + SourcePath + "\' \"" + TargetPath + "\""
        else:
            cmd = DITTO + " -rsrc \'" + SourcePath + "\' \"" + TargetPath + '/' + ObjectName + "\""

    elif ( OpCode == "Delete" ):
        if os.path.exists(TargetPath + '/' + ObjectName):
            if ( createUndo == True ):
                err = createBackup( IsFolder, TargetPath + '/' + ObjectName, PatchFileName)
                if (err == 0):
                    printLog('Writing Backup Command')
                    cmd = DEFAULTS + " write \'" + undoFile + "\' Fileset -array-add \"{ \"OpCode\" = Add; \"TargetPath\" = \'" + RelativeAppPath + "\'; \"IsFolder\" = \'" + IsFolder + "\'; \"PatchFileName\" = \'" + PatchFileName + "\'; \"ObjectName\" = \'" + ObjectName + "\'; \"OrigChecksum\" = \'" + FinalChecksum + "\'; \"FinalChecksum\" = \'"+OrigChecksum+"\'; \"LangID\" = \'" + LangID + "\'; \"UserID\" = \'" + UserID + "\'; \"GroupID\" = \'" + GroupID + "\'; \"Perms\" = \'" + Perms + "\'; }\""
                    printLog(cmd) 
                    os.system(cmd)
            if ( IsFolder == "True" ):
                cmd = RM + " -fR \"" + TargetPath + '/' + ObjectName + "\""
            else:
                cmd = RM + " -f \"" + TargetPath + '/' + ObjectName + "\""
        else:
            cmd = 'true'    #  this is a nop that always returns zero (no error)

    elif (OpCode == "Update" ):
        actualChecksum = calculate_cksum(TargetPath + '/' + ObjectName)
        if actualChecksum == -1:
            printLog('Checksum failed due to bad path: ' + TargetPath + '/' + ObjectName)
            return 1
        if actualChecksum != OrigChecksum:
            if actualChecksum == FinalChecksum:
                printLog('Notice-  this file is already updated:  ' + TargetPath + '/' + ObjectName)
                return 0
            else:
                mes1 = 'ERROR-  Expected Checksum: ' + str(OrigChecksum) + '  Actual Checksum: ' + str(actualChecksum) + '  Final Checksum: ' + str(FinalChecksum)
                printLog(mes1)
                printLog('File: ' + TargetPath + '/' + ObjectName)
                return 1
        if ( createUndo == True ):
            err = createBackup( IsFolder, TargetPath + '/' + ObjectName, PatchFileName)
            if ( err == 0):
                printLog('Writing Backup Command')
                cmd = DEFAULTS + " write \'" + undoFile + "\' Fileset -array-add \"{ \"OpCode\" = Overwrite; \"TargetPath\" = \'" + RelativeAppPath + "\'; \"IsFolder\" = \'" + IsFolder + "\'; \"PatchFileName\" = \'" + PatchFileName + "\'; \"ObjectName\" = \'" + ObjectName + "\'; \"OrigChecksum\" = \'" + FinalChecksum + "\'; \"FinalChecksum\" = \'"+OrigChecksum+"\'; \"LangID\" = \'" + LangID + "\'; \"UserID\" = \'" + UserID + "\'; \"GroupID\" = \'" + GroupID + "\'; \"Perms\" = \'" + Perms + "\'; }\""
                err = os.system(cmd)
                printLog(cmd) 
        cmd = BSPATCH + " \"" + TargetPath + '/' + ObjectName + "\" \"" + TargetPath + '/' + ObjectName + "\" \'" + SourcePath + "\'"

    elif (OpCode == "Rename"):
        if ( createUndo == True ):
            printLog('Writing Backup Command')
            cmd = DEFAULTS + " write \'" + undoFile + "\' Fileset -array-add \"{ \"OpCode\" = \'Rename\'; \"TargetPath\" = \'" + RelativeAppPath + "\'; \"IsFolder\" = \'" + IsFolder + "\'; \"PatchFileName\" = \'" + ObjectName + "\'; \"ObjectName\" = \'" + PatchFileName + "\'; \"OrigChecksum\" = \'" + FinalChecksum + "\'; \"FinalChecksum\" = \'"+OrigChecksum+"\'; \"LangID\" = \'" + LangID + "\'; \"UserID\" = \'" + UserID + "\'; \"GroupID\" = \'" + GroupID + "\'; \"Perms\" = \'" + Perms + "\'; }\""
            err = os.system(cmd)
            printLog(cmd) 
        cmd = MV + " -f \'" + TargetPath + '/' + ObjectName + "\' \'" + TargetPath + "/" + PatchFileName + "\'"

    elif (OpCode == "Custom"):
        if ( createUndo == True ):
            if ( IsFolder == "True" ):
                cmd_string_stat = STAT + " -f \"%Op\" \'" + TargetPath + "/" + ObjectName + "\'" + " | " + COLRM + " 1 2"
            else:
                cmd_string_stat = STAT + " -f \"%Op\" \'" + TargetPath + "/" + ObjectName + "\'" + " | " + COLRM + " 1 3"
            fi =  os.popen(cmd_string_stat, 'r')
            oldPerms = fi.readline()
            oldPerms = oldPerms.rstrip() # remove newline char(s)
            printLog('Writing Backup Command')
            cmd = DEFAULTS + " write \'" + undoFile + "\' Fileset -array-add \"{ \"OpCode\" = Custom; \"TargetPath\" = \'" + RelativeAppPath + "\'; \"IsFolder\" = \'" + IsFolder + "\'; \"PatchFileName\" = \'" + PatchFileName + "\'; \"ObjectName\" = \'" + ObjectName + "\'; \"OrigChecksum\" = \'" + FinalChecksum + "\'; \"FinalChecksum\" = \'"+OrigChecksum+"\'; \"LangID\" = \'" + LangID + "\'; \"UserID\" = \'" + UserID + "\'; \"GroupID\" = \'" + GroupID + "\'; \"Perms\" = \'" + oldPerms + "\'; }\""
            printLog(cmd) 
            err = os.system(cmd)
        if ( IsFolder == "True" ):
           cmd = CHMOD + " -fR " + Perms + " \'" + TargetPath + "/" + ObjectName + "\'"
        else:
           cmd = CHMOD + " -f " + Perms +  " \'" + TargetPath + "/" + ObjectName + "\'"

    elif (OpCode == "Overwrite"):
        if ( createUndo == True ):
            printLog('Writing Backup Command')
            err = createBackup( IsFolder, TargetPath + '/' + ObjectName,PatchFileName )
            if err == 0:
                cmd = DEFAULTS + " write \'" + undoFile + "\' Fileset -array-add \"{ \"OpCode\" = Overwrite; \"TargetPath\" = \'" + RelativeAppPath + "\'; \"IsFolder\" = \'" + IsFolder + "\'; \"PatchFileName\" = \'" + PatchFileName + "\'; \"ObjectName\" = \'" + ObjectName + "\'; \"OrigChecksum\" = \'" + FinalChecksum + "\'; \"FinalChecksum\" = \'"+OrigChecksum+"\'; \"LangID\" = \'" + LangID + "\'; \"UserID\" = \'" + UserID + "\'; \"GroupID\" = \'" + GroupID + "\'; \"Perms\" = \'" + Perms + "\'; }\""
                printLog(cmd) 
                os.system(cmd)

        if ( IsFolder == "True" ):
            cmd = RM + " -fR \"" + TargetPath + '/' + ObjectName + "\""
            err = os.system(cmd)
            cmd = DITTO + " -x \"" + SourcePath + "\" \"" + TargetPath + "\""
        else:
            cmd = DITTO + " -rsrcFork \"" + SourcePath + "\" \"" + TargetPath + '/' + ObjectName + "\""
            
    elif (OpCode == "Write"):
        if ( createUndo == True ):
            printLog('Writing Backup Command')
            path = TargetPath + '/' + ObjectName
            if os.path.exists(path):
                err = createBackup( IsFolder, TargetPath + '/' + ObjectName,PatchFileName )
                if err == 0:
                    cmd = DEFAULTS + " write \'" + undoFile + "\' Fileset -array-add \"{ \"OpCode\" = Overwrite; \"TargetPath\" = \'" + RelativeAppPath + "\'; \"IsFolder\" = \'" + IsFolder + "\'; \"PatchFileName\" = \'" + PatchFileName + "\'; \"ObjectName\" = \'" + ObjectName + "\'; \"OrigChecksum\" = \'" + FinalChecksum + "\'; \"FinalChecksum\" = \'"+OrigChecksum+"\'; \"LangID\" = \'" + LangID + "\'; \"UserID\" = \'" + UserID + "\'; \"GroupID\" = \'" + GroupID + "\'; \"Perms\" = \'" + Perms + "\'; }\""
            else:
                cmd = DEFAULTS + " write \'" + undoFile + "\' Fileset -array-add \"{ \"OpCode\" = Delete; \"TargetPath\" = \'" + RelativeAppPath + "\'; \"IsFolder\" = \'" + IsFolder + "\'; \"PatchFileName\" = \'" + PatchFileName + "\'; ObjectName = \'" + ObjectName + "\'; \"OrigChecksum\" = \'" + FinalChecksum + "\'; \"FinalChecksum\" = \'"+ OrigChecksum + "\'; \"LangID\" = \'" + LangID + "\'; \"UserID\" = \'" + UserID + "\'; \"GroupID\" = \'" + GroupID + "\'; \"Perms\" = \'" + Perms + "\'; }\""
            printLog(cmd) 
            os.system(cmd)

        if ( IsFolder == "True" ):
            cmd = RM + " -fR \"" + TargetPath + '/' + ObjectName + "\""
            err = os.system(cmd)
            cmd = DITTO + " -x \"" + SourcePath + "\" \"" + TargetPath + "\""
        else:
            cmd = DITTO + " -rsrcFork \"" + SourcePath + "\" \"" + TargetPath + '/' + ObjectName + "\""
            
    else:
        printLog('Unknown Command')
        return 1
    
    if err == 0:
        printLog(cmd)
        err = os.system(cmd)

    if err == 0:
        path = TargetPath + '/' + ObjectName
        if OpCode == "Update":
            actualChecksum = calculate_cksum(path)
            if actualChecksum == -1:
                print('Checksum failed due to bad path: ' + path)
                printLog('Checksum failed due to bad path: ' + path)
                return 3
            if (actualChecksum != FinalChecksum):
                mes1 = 'ERROR-  Actual Checksum: ' + str(actualChecksum) + '  Final Checksum: ' + str(FinalChecksum)
                printLog(mes1)
                printLog('File: ' + path)
                return 2
        elif OpCode != "Delete":
            chmodCmd = CHMOD + " -R 0775 \"" + path + "\""
            printLog(chmodCmd)
            err = os.system(chmodCmd)
            chownCmd = CHOWN + " -R -h :admin \"" + path + "\""
            printLog(chownCmd)
            err = os.system(chownCmd)
    else: 
        printLog("Command failed with error: " + str(err))
    return err

####  Check the directory owner value and if Root change to current User
####  Not an error if directory does not exist
def checkAndRepairDirectoryOwner(dirPath):
    cmd1 = "stat -f %Su '" + dirPath + "'"
    printLog(cmd1)
    stat, output = commands.getstatusoutput(cmd1)
    if output == 'root':
        chown_cmd = CHOWN + ' ' + ownerName + " '" + dirPath + "'"
        os.system(chown_cmd)
    printLog("owner: " + output)
    printLog("cmd stat: " + str(stat))
    return

####  Fix directory owner value if necessary
adobePath = os.path.expanduser('~/Library/Application Support/Adobe')
checkAndRepairDirectoryOwner(adobePath)
acrobatPath = os.path.expanduser('~/Library/Application Support/Adobe/Acrobat')
checkAndRepairDirectoryOwner(acrobatPath)

retVal = True
#### Load manifest file dictionary
while (i < length):
    entry = plist.Fileset[i]
    printLog("Processing entry " + str(i+1) + " of manifest")
    err = doOperation(entry)
    i = i + 1
    if (createUndo == True):
        # Undo is created only when processing through manifest file
        # If fails to perform operation from manifest file
        if (err != 0):
            # Start processing through Undo file
            # Should read undo file also
            printLog("Encountered failure at " + str(i) + "th position in Manifest")
            retVal = False
            createUndo = False
            if i == 1:
                length = 0
            else:
                conv_cmd = PLUTIL + " -convert xml1 \'" + undoFileWithExt + "\'"
                err = os.system(conv_cmd)
                plist = plistlib.Plist.fromFile(undoFileWithExt)
                length = len(plist.Fileset)
            i = 0

# Removing the temp files
printLog(rm_cmd)
os.system(rm_cmd)

rm_patch_dir = "find " + "\'" + ADOBE_PATCH_DIR + "\' -type d -empty -exec rmdir {} \\; 2>/dev/null 1>/dev/null"
printLog(rm_patch_dir)
os.system(rm_patch_dir)


exitValue = 1
retString = 'Failure'

if retVal ==  True:
    exitValue = 0
    retString = 'Success'

printLog('Return Value is ' + retString)
output.close()
os._exit(exitValue)
